;
; Solving 1st degree linerar equations
;

format ELF64

section '.data' writeable
dtitle  db       "Linear equations in 1 variable: ax + b = 0", 0Dh, 0Ah, 0
askparm db       "Coefficients a and b? ", 0
frmatin db       "%Lf%Lf", 0
droots  db       "This equation has a unique solution: x = %.3f", 0Dh, 0Ah, 0
dnosol  db       "This equation has no solutions", 0Dh, 0Ah, 0
dinfsol db       "This equation has an infinity of solutions", 0Dh, 0Ah, 0
a       dq       0.0
b       dq       0.0

section '.text' executable
public main
extrn printf
extrn scanf
main:
        push     rbp
        mov      rbp, rsp;
        sub      rsp, 32
        and      rsp, -16
        mov      rcx, dtitle
        call     printf
        mov      rcx, askparm
        call     printf
        mov      rcx, frmatin
        mov      rdx, a
        mov      r8, b
        call     scanf
        movsd    xmm0, [a]
        movsd    xmm1, [b]
        pxor     xmm2, xmm2
        cmpeqsd  xmm2, xmm0
        movd     eax, xmm2
        test     eax, eax
        jnz      notunique
        pxor     xmm2, xmm2
        subsd    xmm2, xmm1
        divsd    xmm2, xmm0
        mov      rcx, droots
        movq     rdx, xmm2
        jmp      done
notunique:
        pxor     xmm2, xmm2
        cmpeqsd  xmm2, xmm1
        movd     eax, xmm2
        test     eax, eax
        jnz      infsol
        mov      rcx, dnosol
        jmp      done
infsol:
        mov      rcx, dinfsol
done:
        call     printf
        mov      rsp, rbp
        pop      rbp
        xor      rax, rax
        ret
