;
; "Guess the number" game
;

format ELF64

section '.data' writeable
nlow    equ      1
nhigh   equ      100
count   dq       0
gtitle  db       'Guess the Number game in x64 Assembly (FASM).', 0Dh, 0Ah, 0
qnumber db       'Please, enter a number between 1 and 100? ', 0
bnumber db       'Your number is to big!', 0Dh, 0Ah, 0
snumber db       'Your number is to small!', 0Dh, 0Ah, 0
enumber db       'Congratulations! You have found the number in %llu guesses.', 0Dh, 0Ah, 0
frmatin db       '%llu', 0

section '.bss' writeable
rnum    dq       ?
unum    dq       ?

section '.text' executable
public main
extrn printf
extrn scanf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, gtitle
        call    printf
try_rand:
        rdrand  rax
        jnc     try_rand
        xor     rdx, rdx
        mov     rbx, nhigh - nlow + 1
        div     rbx
        add     rdx, nlow
        mov     [rnum], rdx
next:
        mov     rcx, qnumber
        call    printf
        mov     rcx, frmatin
        mov     rdx, unum
        call    scanf
        mov     rax, [unum]
        cmp     rax, nlow
        jl      done
        cmp     rax, nhigh
        jg      done
        inc     qword [count]
        cmp     rax, [rnum]
        jl      tosmall
        jg      tobig
        mov     rcx, enumber
        mov     rdx, [count]
        call    printf
        jmp     done
tosmall:
        mov     rcx, snumber
        call    printf
        jmp     next
tobig:
        mov     rcx, bnumber
        call    printf
        jmp     next
done:
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret
