;
; Equation of a line passing through two points
;

format ELF64

section '.data' writeable
askpt1  db       "Coefficients x and y of point A? ", 0
askpt2  db       "Coefficients x and y of point B? ", 0
frmatin db       "%Lf%Lf", 0
line1   db       "Equation of the line (AB): y = %.2fx + %.2f", 0Dh, 0Ah, 0
line1b  db       "Equation of the line (AB): y = %.2fx - %.2f", 0Dh, 0Ah, 0
line1c  db       "Equation of the line (AB): y = %.2f", 0Dh, 0Ah, 0
line2   db       "Equation of the line (AB): x = %.2f", 0Dh, 0Ah, 0

section '.bss' writeable
x1      dq       ?
y1      dq       ?
x2      dq       ?
y2      dq       ?

section '.text' executable
public main
extrn printf
extrn scanf
main:
        push     rbp
        mov      rbp, rsp;
        sub      rsp, 32
        and      rsp, -16
        mov      rcx, askpt1
        call     printf
        mov      rcx, frmatin
        mov      rdx, x1
        mov      r8, y1
        call     scanf
        mov      rcx, askpt2
        call     printf
        mov      rcx, frmatin
        mov      rdx, x2
        mov      r8, y2
        call     scanf
        movsd    xmm1, [x2]
        subsd    xmm1, [x1]
        pxor     xmm2, xmm2
        cmpeqsd  xmm2, xmm1
        movd     eax, xmm2
        test     eax, eax
        jnz      parallel_y
        movsd    xmm0, [y2]
        subsd    xmm0, [y1]
        divsd    xmm0, xmm1
        pxor     xmm2, xmm2
        cmpeqsd  xmm2, xmm0
        movd     eax, xmm2
        test     eax, eax
        jnz      parallel_x
        movsd    xmm3, xmm0
        mulsd    xmm0, [x1]
        movsd    xmm1, [y1]
        subsd    xmm1, xmm0
        movq     rdx, xmm3
        pxor     xmm2, xmm2
        cmpltsd  xmm2, xmm1
        movd     eax, xmm2
        test     eax, eax
        jz       negative_oy
        movq     r8, xmm1
        mov      rcx, line1
        jmp      eq_print
negative_oy:
        pxor     xmm2, xmm2
        subsd    xmm2, xmm1
        movq     r8, xmm2
        mov      rcx, line1b
        jmp      eq_print
parallel_x:
        movq     rdx, xmm1
        mov      rcx, line1c
        jmp      eq_print
parallel_y:
        movsd    xmm0, [x1]
        movq     rdx, xmm0
        mov      rcx, line2
eq_print:
        call     printf
        mov      rsp, rbp
        pop      rbp
        xor      rax, rax
        ret
