;
; Addition of two matrices
;

format ELF64

section '.data' writeable
rows    equ     2
cols    equ     2
dsize   equ     8
matrix1 dq      100, 200
        dq      -200, -100
matrix2 dq      100, -100
        dq      100, -100
frmat   db      "%4Li   ", 0
eol     db      0Dh, 0Ah, 0

section '.bss' writeable
srow    dq      ?
scol    dq      ?

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rax, 0
next_row:
        cmp     rax, rows
        je      done
        mov     rbx, 0
next_col:
        cmp     rbx, cols
        je      continue
        mov     [srow], rax
        mov     [scol], rbx
        mov     rcx, cols
        mov     rdx, dsize
        call    element_offset
        mov     rdx, [matrix1+rax]
        add     rdx, [matrix2+rax]
        mov     rcx, frmat
        call    printf
        mov     rax, [srow]
        mov     rbx, [scol]
        inc     rbx
        jmp     next_col
continue:
        mov     rcx, eol
        call    printf
        mov     rax, [srow]
        inc     rax
        jmp     next_row
done:
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret

;
; Calculate two dimensional arry element offset
;
; Input:  RAX: Row-offset
;         RBX: Column-offset
;         RCX: Number of columns in array
;         RDX: Size of elements data type
; Output: RAX: element offset

element_offset:
        push    rdx
        imul    rcx
        add     rax, rbx
        pop     rdx
        imul    rdx
        ret
