;
; Random number series (using rdrand instruction)
;

format ELF64

section '.data' writeable
nums    equ     100
nlow    equ     1
nhigh   equ     99
count   dq      0
frmat   db      "%2llu  ", 0
eol     db      0Dh, 0Ah, 0

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, 0
next:
        cmp     rcx, nums
        je      done
try_rand:
        rdrand  rax
        jnc     try_rand
        xor     rdx, rdx
        mov     rbx, nhigh - nlow + 1
        div     rbx
        add     rdx, nlow
        mov     [count], rcx
        mov     rcx, frmat
        call    printf
        xor     rdx, rdx
        mov     rax, [count]
        inc     rax
        mov     rbx, 10
        div     rbx
        cmp     rdx, 0
        jne     continue
        mov     rcx, eol
        call    printf
continue:
        mov     rcx, [count]
        inc     rcx
        jmp     next
done:
        mov     rcx, eol
        call    printf
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret
